<template>
  <b-card-code
    title="Historial de asistencia"
    no-body

  >
      <div class="m-2">
        <b-row>   

           <b-row>
            <b-col
              cols="12"
              md="6"
            >
            </b-col>
          </b-row>
          <b-row>
            <b-col
              cols="12"
              md="6"
              class="d-flex align-items-center justify-content-start mb-1 mb-md-0"
            >
              <label for="datepicker-full-width">Escoge un rango de fechas para el historial de asistencias</label>
            </b-col>

            <b-col
              cols="12"
              md="12"
            >
              <div class="d-flex align-items-center justify-content-end">
                
                  <b-form-datepicker
                    id="start_date"
                    v-model="start_date"
                    menu-class="w-100"
                    :state="checkDateRange"
                    calendar-width="100%"
                  />
                  <b-form-datepicker
                    id="end_date"
                    v-model="end_date"
                    menu-class="w-100"
                    :state="checkDateRange"
                    calendar-width="100%"
                  />
              </div>
              
              
            </b-col>
            
            </b-row>
             <div class="d-flex mt-2">
             <b-button 
              type="button"
                class="ml-4"
              @click="$router.back()">
               Regresar
            </b-button>
           </div>
        </b-row>
      </div>
    <b-table
      :fields="fields"
      :items="attendance"
      responsive
      :filter="searchQuery"
      class="mb-0"
      show-empty
      empty-text="No se encontraron registros"
    >

      <!-- A virtual column -->
      <template #cell(index)="data">
        {{ data.item.id  }}
      </template>

       <template #cell(delayed)="data">
          <span v-if="data.item.delayed===1">Si</span>
          <span v-else>No</span>
        </template>

       <!-- Column: Actions -->
        <template #cell(actions)="data">
          <b-dropdown
            variant="link"
            no-caret
          >

            <template #button-content>
              <feather-icon
                icon="MoreVerticalIcon"
                size="16"
                class="align-middle text-body"
              />
            </template>
            <b-dropdown-item :to="{ name: 'apps-users-attendance-history-view', params: { attendance: data.item.id } }">
              <feather-icon icon="FileTextIcon" />
              <span class="align-middle ml-50">Detalles</span>
            </b-dropdown-item>

        
          </b-dropdown>
        </template>


    </b-table>
  
    
  </b-card-code>
</template>

<script>
import BCardCode from '@core/components/b-card-code/BCardCode.vue'
import {
  BRow, BCol, BFormInput, BButton, BTable, BMedia, BAvatar, BLink,
  BBadge, BDropdown, BDropdownItem, BProgress,  BFormDatepicker
} from 'bootstrap-vue'


export default {
  name:'attendance-list',
  components: {
    BCardCode,
    BRow,
    BCol,
    BFormInput,
    BButton,
    BTable,
    BMedia,
    BAvatar,
    BLink,
    BBadge,
    BDropdown,
    BDropdownItem,
    BProgress,
    BFormDatepicker,
   


  },
  data() {
    return {
      fields: [
        'index',
        { key: 'date', label: 'Fecha' },
        { key: 'start_time', label: 'Hora de entrada' },
        { key: 'end_time', label: 'Hora de salida' },
        { key: 'worked_hours', label: 'Horas trabajadas'},
        {key: 'delayed', label: 'Retardo'},
        {key: 'actions', label: 'Acciones'}
      ],
      start_date:'',
      end_date:'',
      attendance: [],
      allAttendance: [],
      searchQuery:'',
      baseURL:'http://quantumdaily-back.test/storage/',

    }
  },
  methods:{
    getAttendance(){

      this.$http.get('user/attendance/history',{params:{user:this.$route.params.id}}).then(res=>{
        this.allAttendance = res.data.attendance
        this.attendance = res.data.attendance
        console.log(this.attendance)
      }).catch(err=>{
        console.log(err)
      })
    },
    reload(e){
      this.getAttendance()
    },
  
    getDates(){
      let todayDate = new Date();
      let lastWeekDay = new Date(new Date().getTime()-(7*24*60*60*1000));
      this.start_date = lastWeekDay.toISOString().split('T')[0];
      this.end_date = todayDate.toISOString().split('T')[0];
    
    },
 
 
  },
  computed:{
    checkDateRange(){
      if(this.start_date != '' && this.end_date != ''){
        this.attendance = this.allAttendance.filter(attendance => attendance.date >= this.start_date && attendance.date <= this.end_date);
      }
    }
  },
  mounted(){
    this.getAttendance()
    this.getDates()
  }
  


}
</script>

<style lang="scss" scoped>
.per-page-selector {
  width: 90px;
}
</style>

<style lang="scss">
@import '@core/scss/vue/libs/vue-select.scss';
</style>
